<template>
    <div id="cumulus-loading-spinner">
        <div class="spinner-container" :class="{'full-screen': fullScreen}">
            <div class="spinner-circle-container" :class="{'spinner-centered': fullScreen}">
                <div :style="{height: height, width: width}" class="spinner-circle">
                    <div class="spinner-circle inner-circle"></div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'CumulusLoadingSpinner',
    props: {
        fullScreen: {
            default: false,
            type: Boolean,
        },
        height: {
            default: '120px',
            type: String,
        },
        width: {
            default: '120px',
            type: String,
        },
    },
};
</script>
<style lang="scss" scoped>
.spinner-circle {
    border: 10px solid rgba(189, 189, 189, 0.25);
    border-left-color: #76b900;
    border-top-color: #76b900;
    border-radius: 50%;
    animation: spinner-rotate 2100ms infinite
        cubic-bezier(0, 0.2, 1, 0.8);

  .inner-circle {
      width: calc(100% - 20px);
      height: calc(100% - 20px);
  }
}

.spinner-circle-container.spinner-centered {
    transform: translateX(-50%);
    position: absolute;
    left: 50%;
    top: 50%;
}

.spinner-container.full-screen {
    position: absolute;
    z-index: 999;
    height: 100vh;
    width: 100vw;
    background-color: rgba(10, 10, 10, 0.46);
    backdrop-filter: blur(5px);
}

@keyframes spinner-rotate {
    to {
        transform: rotate(1turn);
    }
}
</style>
